/* $Id: common.c,v 1.1 2002/07/22 07:58:49 jirka Exp $ */

#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include "common.h"

static unsigned long long bytes = 0;
static int after = DEFAULT_HASH_AFTER * KILO;
static unsigned long long hashes = 0;
static time_t start;

static void print_bytes(unsigned long long bytes)
{
    if (bytes >= GIGA)
        fprintf(stderr, " %7.2f GBytes", bytes / (1.0 * GIGA));
    else if (bytes >= MEGA)
        fprintf(stderr, " %7.2f MBytes", bytes / (1.0 * MEGA));
    else if (bytes >= KILO)
        fprintf(stderr, " %7.2f KBytes", bytes / (1.0 * KILO));
    else
        fprintf(stderr, " %7d Bytes", (int) bytes);
}

void hash_after(int kbytes)
{
    after = (kbytes <= 0 ? DEFAULT_HASH_AFTER : kbytes) * KILO;
}

void print_hashes(unsigned long transferred_bytes)
{
    if (bytes == 0)
        start = time(NULL);

    bytes += transferred_bytes;
    while ((bytes / after) >= (hashes + 1)) {
        hashes++;
        write(STDERR_FILENO, "#", 1);
        if (hashes % 50 == 0) {
            write(STDERR_FILENO, " ", 1);
            print_bytes(hashes * after);
            write(STDERR_FILENO, "\n", 1);
        }
        else if (hashes % 10 == 0)
            write(STDERR_FILENO, " ", 1);
    }

    fflush(stderr);
}

void print_summary(void)
{
    double speed;
    double diff;

    fprintf(stderr, "\n");
    print_bytes(bytes);
    fprintf(stderr, " transferred at ");

    diff = difftime(time(NULL), start);
    speed = (diff == 0 ? 0 : bytes / diff);
    if (speed > GIGA)
        fprintf(stderr, "%0.2f GB/s", speed / (1.0 * GIGA));
    else if (speed > MEGA)
        fprintf(stderr, "%0.2f MB/s", speed / (1.0 * MEGA));
    else if (speed > KILO)
        fprintf(stderr, "%0.2f KB/s", speed / (1.0 * KILO));
    else
        fprintf(stderr, "%0.2f B/s", speed);
    fprintf(stderr, " (%d seconds)\n", (int) diff);

    fflush(stderr);
}

