/* $Id: common.h,v 1.2 2002/07/22 08:23:09 jirka Exp $ */

#define KILO 1024
#define MEGA 1024 * KILO
#define GIGA 1024 * MEGA

#define BUFFSIZE 1 << 14 /* 16 KB */
#define DEFAULT_HASH_AFTER 10 * 1024  /* in KB == 10 MB */

/* options processing */
#define HASH_OPT "H:h:"
#define HASH_USAGE \
    "  -h <n>           print `#' after each n KB transferred (def. 10240)\n" \
    "  -H <n>           print `#' after each n MB transferred (def. 10)\n"
#define HASH_CASE \
    case 'H':           /* print hash after n MB */ \
        hash_after(atoi(optarg) * 1024);            \
        break;                                      \
    case 'h':           /* print hash after n KB */ \
        hash_after(atoi(optarg));                   \
        break;

#define VERBOSITY_OPT "qv"
#define VERBOSITY_USAGE \
    "  -q               quiet\n" \
    "  -v               verbose\n"
#define VERBOSITY_CASE \
    case 'q':           /* quiet */     \
        quiet = 1;                      \
        break;                          \
    case 'v':           /* verbose */   \
        verbose = 1;                    \
        break;

/* read/write functions */
#define read_sock(sock, buf, r_addr, size) \
    (udp ? recvfrom(sock, buf, sizeof(buf), 0, r_addr, size) \
         : read(sock, buf, sizeof(buf)))

#define write_sock(sock, buf, count, addr, size) \
    (udp ? sendto(sock, buf, count, 0, addr, size) \
         : write(sock, buf, count))

/* hash printing functions */
void hash_after(int kbytes);

void print_hashes(unsigned long transferred_bytes);

void print_summary(void);

